<?php
/**
 * InlineResponse2002ContentMails
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse2002ContentMails Class Doc Comment
 *
 * @category Class
 * @description describes a mail object
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse2002ContentMails implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_2_content_mails';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'senderId' => 'int',
        'senderName' => 'string',
        'senderEmail' => 'string',
        'subject' => 'string',
        'bodyHtml' => 'string',
        'bodyPlain' => 'string',
        'plainTextOnly' => 'bool',
        'inbound' => 'bool',
        'internal' => 'bool',
        'receivers' => '\SLIS\Adapter\Tanss\Model\InlineResponse2002ContentReceivers[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'senderId' => null,
        'senderName' => null,
        'senderEmail' => null,
        'subject' => null,
        'bodyHtml' => null,
        'bodyPlain' => null,
        'plainTextOnly' => null,
        'inbound' => null,
        'internal' => null,
        'receivers' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'senderId' => 'senderId',
        'senderName' => 'senderName',
        'senderEmail' => 'senderEmail',
        'subject' => 'subject',
        'bodyHtml' => 'bodyHtml',
        'bodyPlain' => 'bodyPlain',
        'plainTextOnly' => 'plainTextOnly',
        'inbound' => 'inbound',
        'internal' => 'internal',
        'receivers' => 'receivers'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'senderId' => 'setSenderId',
        'senderName' => 'setSenderName',
        'senderEmail' => 'setSenderEmail',
        'subject' => 'setSubject',
        'bodyHtml' => 'setBodyHtml',
        'bodyPlain' => 'setBodyPlain',
        'plainTextOnly' => 'setPlainTextOnly',
        'inbound' => 'setInbound',
        'internal' => 'setInternal',
        'receivers' => 'setReceivers'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'senderId' => 'getSenderId',
        'senderName' => 'getSenderName',
        'senderEmail' => 'getSenderEmail',
        'subject' => 'getSubject',
        'bodyHtml' => 'getBodyHtml',
        'bodyPlain' => 'getBodyPlain',
        'plainTextOnly' => 'getPlainTextOnly',
        'inbound' => 'getInbound',
        'internal' => 'getInternal',
        'receivers' => 'getReceivers'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['senderId'] = $data['senderId'] ?? null;
        $this->container['senderName'] = $data['senderName'] ?? null;
        $this->container['senderEmail'] = $data['senderEmail'] ?? null;
        $this->container['subject'] = $data['subject'] ?? null;
        $this->container['bodyHtml'] = $data['bodyHtml'] ?? null;
        $this->container['bodyPlain'] = $data['bodyPlain'] ?? null;
        $this->container['plainTextOnly'] = $data['plainTextOnly'] ?? null;
        $this->container['inbound'] = $data['inbound'] ?? null;
        $this->container['internal'] = $data['internal'] ?? null;
        $this->container['receivers'] = $data['receivers'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id of the mail
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets senderId
     *
     * @return int|null
     */
    public function getSenderId()
    {
        return $this->container['senderId'];
    }

    /**
     * Sets senderId
     *
     * @param int|null $senderId id of the mail sender (if a tanss employee could be matches)
     *
     * @return self
     */
    public function setSenderId($senderId)
    {
        $this->container['senderId'] = $senderId;

        return $this;
    }

    /**
     * Gets senderName
     *
     * @return string|null
     */
    public function getSenderName()
    {
        return $this->container['senderName'];
    }

    /**
     * Sets senderName
     *
     * @param string|null $senderName name of the sender
     *
     * @return self
     */
    public function setSenderName($senderName)
    {
        $this->container['senderName'] = $senderName;

        return $this;
    }

    /**
     * Gets senderEmail
     *
     * @return string|null
     */
    public function getSenderEmail()
    {
        return $this->container['senderEmail'];
    }

    /**
     * Sets senderEmail
     *
     * @param string|null $senderEmail e-Mail of the sender
     *
     * @return self
     */
    public function setSenderEmail($senderEmail)
    {
        $this->container['senderEmail'] = $senderEmail;

        return $this;
    }

    /**
     * Gets subject
     *
     * @return string|null
     */
    public function getSubject()
    {
        return $this->container['subject'];
    }

    /**
     * Sets subject
     *
     * @param string|null $subject subject of the mail
     *
     * @return self
     */
    public function setSubject($subject)
    {
        $this->container['subject'] = $subject;

        return $this;
    }

    /**
     * Gets bodyHtml
     *
     * @return string|null
     */
    public function getBodyHtml()
    {
        return $this->container['bodyHtml'];
    }

    /**
     * Sets bodyHtml
     *
     * @param string|null $bodyHtml html body
     *
     * @return self
     */
    public function setBodyHtml($bodyHtml)
    {
        $this->container['bodyHtml'] = $bodyHtml;

        return $this;
    }

    /**
     * Gets bodyPlain
     *
     * @return string|null
     */
    public function getBodyPlain()
    {
        return $this->container['bodyPlain'];
    }

    /**
     * Sets bodyPlain
     *
     * @param string|null $bodyPlain plain body
     *
     * @return self
     */
    public function setBodyPlain($bodyPlain)
    {
        $this->container['bodyPlain'] = $bodyPlain;

        return $this;
    }

    /**
     * Gets plainTextOnly
     *
     * @return bool|null
     */
    public function getPlainTextOnly()
    {
        return $this->container['plainTextOnly'];
    }

    /**
     * Sets plainTextOnly
     *
     * @param bool|null $plainTextOnly true, if mail was sent \"only plain\"
     *
     * @return self
     */
    public function setPlainTextOnly($plainTextOnly)
    {
        $this->container['plainTextOnly'] = $plainTextOnly;

        return $this;
    }

    /**
     * Gets inbound
     *
     * @return bool|null
     */
    public function getInbound()
    {
        return $this->container['inbound'];
    }

    /**
     * Sets inbound
     *
     * @param bool|null $inbound true, if the mail was incoming
     *
     * @return self
     */
    public function setInbound($inbound)
    {
        $this->container['inbound'] = $inbound;

        return $this;
    }

    /**
     * Gets internal
     *
     * @return bool|null
     */
    public function getInternal()
    {
        return $this->container['internal'];
    }

    /**
     * Sets internal
     *
     * @param bool|null $internal true, if the mail is \"internal\" only
     *
     * @return self
     */
    public function setInternal($internal)
    {
        $this->container['internal'] = $internal;

        return $this;
    }

    /**
     * Gets receivers
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse2002ContentReceivers[]|null
     */
    public function getReceivers()
    {
        return $this->container['receivers'];
    }

    /**
     * Sets receivers
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse2002ContentReceivers[]|null $receivers receivers
     *
     * @return self
     */
    public function setReceivers($receivers)
    {
        $this->container['receivers'] = $receivers;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


